﻿using System;
using System.DirectoryServices;
using System.Collections.Generic;
using System.Web.Script.Serialization;
using System.Net;
using System.Collections.Specialized;

public partial class DebugFetchOus : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string domain = Request.QueryString["domain"];
        Response.Write("Start <br>");

        if (domain != null)
        {
			try
			{
				DirectoryEntry startingPoint = new DirectoryEntry("LDAP://dc=" + domain.Replace(".", ";dc="), null, null, AuthenticationTypes.Secure);
				DirectorySearcher searcher = new DirectorySearcher(startingPoint);

				searcher.Filter = "(&(objectCategory=person)(objectClass=user))";
				searcher.SearchScope = SearchScope.Subtree;

				searcher.Sort = new SortOption("cn", SortDirection.Ascending);
				searcher.PageSize = 500;
				SearchResult result = searcher.FindOne();
				Response.Write(result.Path);
				Response.Write("<br>Success");
				return;
			}
			catch(Exception ex) {
				Response.Write(ex.Message);
			}
        }

        Response.StatusCode = 400;
        Response.StatusDescription = "Valid domain is required";
        Response.Write("Valid domain is required");
    }
}