﻿using System;
using System.DirectoryServices;
using System.Collections.Generic;
using System.Web.Script.Serialization;
using System.Net;
using System.Collections.Specialized;
using System.Text.RegularExpressions;
using System.IO;

public partial class _Default : System.Web.UI.Page
{
    protected void Page_Load(object sender, EventArgs e)
    {
        string result = string.Empty;
        string domain = Request.QueryString["domain"];
        string token = Request.QueryString["token"];
        string hostName = Request.QueryString["hostname"];
        bool isLoggin = false;
        string logpath = "c:\\temp\\output" + DateTime.Now.ToString("yyyyMMddHsf") +".txt";
        System.IO.StreamWriter file = null;

        if (isLoggin == true && !Directory.Exists("C:\\temp")) {
			Directory.CreateDirectory("C:\\temp");
		}

        if (domain !=null && domain.ToLower() == "securly_test")
        {
            Response.StatusCode = 200;
            Response.StatusDescription = "Success";
            Response.Write("Success");
            return;
        }

        if(isLoggin == true){
            file = new System.IO.StreamWriter(logpath , true);
            file.WriteLine("Debug Log for FetchOUs");
            file.WriteLine("START:" + DateTime.Now.ToString());
            file.WriteLine(domain);
            file.WriteLine(token);
            file.WriteLine(hostName);
        }

        if (domain != null && token != null && hostName != null){
			try{
				DirectoryEntry startingPoint = new DirectoryEntry("LDAP://dc=" + domain.Replace(".", ";dc="), null, null, AuthenticationTypes.Secure);
				DirectorySearcher searcher = new DirectorySearcher(startingPoint);
				
				searcher.Filter = "(&(objectCategory=person)(objectClass=user))";
				searcher.SearchScope = SearchScope.Subtree;
			   
				searcher.Sort = new SortOption("cn", SortDirection.Ascending);
				searcher.PageSize = 500;
				//searcher.VirtualListView = new DirectoryVirtualListView(0, 3, 2);

				var counter = 0;
				var page = 0;
				List<Dictionary<string, string>> users = new List<Dictionary<string, string>>();
				WebClient client = new WebClient();
				foreach (SearchResult item in searcher.FindAll())
				{
					string path = item.Path.Replace("LDAP://", "");
					int numb = path.IndexOf(",OU=");
					string[] vals = null;
					Dictionary<string, string> dict = new Dictionary<string, string>();
				   
					if (numb > 0)
					{
						vals = path.Split(new[] { "OU=", "," }, StringSplitOptions.RemoveEmptyEntries);
						string ouPath = null;
						Array.Reverse(vals);
						foreach(string val in vals)
						{
							if (val.IndexOf("CN=") == 0)
							{
								try{
								    dict["primaryEmail"] = item.Properties["mail"][0].ToString();
								} catch(Exception ex) {

									if(isLoggin == true && (item.Properties["mail"] == null || item.Properties["mail"].Count == 0))
									{
										file.WriteLine("mail does not exist for " + val);
									}
									if(isLoggin == true){
									    file.WriteLine("item count: " + item.Properties.Count);
									    file.WriteLine("mail catch:" + ex.Message ); // + ex.ToString());
									}
									dict["primaryEmail"] = val.Substring(val.IndexOf('=')+1);
								}
							}
							else if (val.IndexOf("DC=") == 0) { }
							else
							{
								ouPath += val.Replace("OU=", "") + "/";
							}
						}
						if (isLoggin == true) {
							// Detect and log if invalid characters are detected.
							Regex badPattern = new Regex(@"[""\\/\[\]:;|=,+\*?<>]");
							if (badPattern.IsMatch(dict["primaryEmail"])) {
								file.WriteLine("Invalid email detected " + dict["primaryEmail"] + ", this user will receive base/default policy.");
							}
						}
						dict["orgUnitPath"] = ouPath;
						users.Add(dict);
						if(isLoggin == true){
						    file.WriteLine("counter: " + counter + " 	upn: " + dict["primaryEmail"] + "	ou path " + ouPath);
						}
						if (counter>0 && counter % 500 == 0)
						{

                            if(isLoggin == true){
                                file.WriteLine("Counter hit 500 start sending");
                                file.WriteLine("Domain: " + domain );
                                file.WriteLine("Page: " +  (Convert.ToInt32(counter/500)).ToString());
                                file.WriteLine(new JavaScriptSerializer().Serialize(users));
                                file.WriteLine("UploadValues Start:" + DateTime.Now.ToString());
                                file.WriteLine("https://"+ hostName +"/app/api/ouImport.php");
                                file.WriteLine(new JavaScriptSerializer().Serialize(users));
                            }
							//let's make a post here
							page = page + 1;
							byte[] response = client.UploadValues("https://"+ hostName +"/app/api/ouImport.php", new NameValueCollection()
											{
												{ "token", token}, {"fo_domain", domain }, { "page", page.ToString() }, { "data",  new JavaScriptSerializer().Serialize(users)}
											});

							if(isLoggin == true){
							    file.WriteLine("UploadValues Complete:" + DateTime.Now.ToString());
							}
							if(System.Text.Encoding.UTF8.GetString(response).Contains("Success") == false)
							{
							    if(isLoggin == true){
							        file.WriteLine("response error" + System.Text.Encoding.UTF8.GetString(response));
							    }
								return;
							}
							//counter = 0;
							users.Clear();
							dict.Clear();
							 
						}
						counter++;
					}
				   
				}
				
				if(isLoggin == true){
				    file.WriteLine("Submit ouImport");
				}
				page = page + 1;
				Response.Write(System.Text.Encoding.UTF8.GetString(client.UploadValues("https://"+hostName+"/app/api/ouImport.php", new NameValueCollection()
											{
												{ "token", token}, {"fo_domain", domain },  { "page", page.ToString() }, { "data",  new JavaScriptSerializer().Serialize(users)}
											})));

				if(isLoggin == true){
                    file.WriteLine("Submit/Upload here");
                    file.WriteLine("FINISH:" + DateTime.Now.ToString());
                    file.Close();
				}
				return;
			}
			catch(Exception ex) {
			    if(isLoggin == true){
                    file.WriteLine("Catch block:" + ex.Message + ex.ToString());
                    file.WriteLine("ERRFINISH:" + DateTime.Now.ToString());
                    file.Close();
                }
				Response.StatusCode = 520;
       			Response.StatusDescription = "A problem has occured while processing the request.";
       			Response.Write("Something went wrong: " + ex.Message);
				return;
			}
        }

        if(isLoggin == true){
            file.WriteLine("400 Error - Valid domain is required");
        }
        Response.StatusCode = 400;
        Response.StatusDescription = "Valid domain is required";
        Response.Write("Valid domain is required");
        if(isLoggin == true){
            file.WriteLine("ERRFINISH:" + DateTime.Now.ToString());
            file.Flush();
            file.Close();
        }
    }
}
